﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class IntroLogo : MonoBehaviour
{
    #region Constants

    //****************************************************************************************************************
    //**                                                   Public                                                   **
    //****************************************************************************************************************

    //****************************************************************************************************************
    //**                                                  Protected                                                 **
    //****************************************************************************************************************

    //****************************************************************************************************************
    //**                                                   Private                                                  **
    //****************************************************************************************************************

    #endregion Constants

    #region Fields

    //****************************************************************************************************************
    //**                                                 Serialised                                                 **
    //****************************************************************************************************************

    [SerializeField] private float timeBeforeFade;

    [SerializeField] private float fadeDuration;

    [SerializeField] private AudioClip jingle;

    [SerializeField] private float timeBetweenFadeAndJingle;

    [SerializeField] private float timeAfterJingleEnd;

    [SerializeField] private float timeAfterFade;

    //****************************************************************************************************************
    //**                                          Public (HideInInspector)                                          **
    //****************************************************************************************************************

    //****************************************************************************************************************
    //**                                                  Protected                                                 **
    //****************************************************************************************************************

    //****************************************************************************************************************
    //**                                                   Private                                                  **
    //****************************************************************************************************************

    #endregion Fields

    #region Properties

    //****************************************************************************************************************
    //**                                                   Public                                                   **
    //****************************************************************************************************************

    //****************************************************************************************************************
    //**                                                  Protected                                                 **
    //****************************************************************************************************************

    //****************************************************************************************************************
    //**                                                   Private                                                  **
    //****************************************************************************************************************

    #endregion Properties

    #region Methods

    #region Unity

    //****************************************************************************************************************
    //**                                             For Unity Methods                                              **
    //****************************************************************************************************************

    #endregion Unity

    #region Virtual/Override

    //****************************************************************************************************************
    //**                                                   Public                                                   **
    //****************************************************************************************************************

    //****************************************************************************************************************
    //**                                                  Protected                                                 **
    //****************************************************************************************************************

    //****************************************************************************************************************
    //**                                                   Private                                                  **
    //****************************************************************************************************************

    #endregion Virtual/Override

    #region Others

    //****************************************************************************************************************
    //**                                                   Public                                                   **
    //****************************************************************************************************************

    public void StartJingle()
    {
        Application.targetFrameRate = 60;
        StartCoroutine(JingleCoroutine());
    }

    //****************************************************************************************************************
    //**                                                  Protected                                                 **
    //****************************************************************************************************************

    //****************************************************************************************************************
    //**                                                   Private                                                  **
    //****************************************************************************************************************

    #endregion Others

    #region Coroutines

    //****************************************************************************************************************
    //**                                                   Public                                                   **
    //****************************************************************************************************************

    //****************************************************************************************************************
    //**                                                  Protected                                                 **
    //****************************************************************************************************************

    protected IEnumerator JingleCoroutine()
    {
        yield return new WaitForSeconds(timeBeforeFade);
        Color color = new Color(1, 1, 1, 0);
        SpriteRenderer sprite = GetComponent<SpriteRenderer>();
        float end = Time.time + fadeDuration;
        while (Time.time < end)
        {
            color = new Color(1, 1, 1, (Time.time - end + fadeDuration) / fadeDuration);
            sprite.color = color;
            yield return null;
        }
        sprite.color = Color.white;

        yield return new WaitForSeconds(timeBetweenFadeAndJingle);

        AudioSource audio = GetComponent<AudioSource>();
        if (jingle != null)
            audio.PlayOneShot(jingle);
        if (jingle != null)
            yield return new WaitForSeconds(jingle.length + timeAfterJingleEnd);

        end = Time.time + fadeDuration;
        while (Time.time < end)
        {
            color = new Color(1, 1, 1, 1 - ((Time.time - end + fadeDuration) / fadeDuration));
            sprite.color = color;
            yield return null;
        }
        sprite.color = new Color(1, 1, 1, 0);

        yield return new WaitForSeconds(timeAfterFade);

        LoadingScreenManager.Instance.LoadLevel("MainMenu");
    }

    //****************************************************************************************************************
    //**                                                   Private                                                  **
    //****************************************************************************************************************

    #endregion Coroutines

    #endregion Methods
}